/*	Diese Datei erzeugt das Logfenster in dem die Zeiten
	in Klartext enthalten sind.	*/
	
#include "LogWin.h"
#include <InterfaceKit.h>
#include <AppKit.h>
#include <stdio.h>
#include <stdlib.h>

/* Das ist der Constructor!*/

LogWin::LogWin(BRect frame) 
	: BWindow(frame, "DebugWin", B_TITLED_WINDOW, 0)

{
	BRect 				rect = frame;
	BRect				insrect;
	BTextView			*btview;
	BScrollView			*scv;
	thread_id			trid;
	pid_i =  create_port(10, PORT_NAME);

	rect.OffsetTo(B_ORIGIN);
	rect.right -= B_V_SCROLL_BAR_WIDTH;
	insrect = rect;
	insrect.InsetBy(5,5);
	btview = new BTextView(rect, "view", insrect, B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE); 

	scv = new BScrollView("scr", btview, B_FOLLOW_ALL_SIDES, 0, false, true);
	AddChild(scv);

	trid = spawn_thread(read_thread, "ReadDebugWin", B_NORMAL_PRIORITY, btview);
	if (trid < B_NO_ERROR) {
		printf("Fehler beim Starten!\n");
		switch (trid) {
			case B_NO_MORE_THREADS: printf("Zuviele Threads\n"); break;
			case B_NO_MEMORY: printf("Zuwenig Speicher\n"); break;
			default: printf("Unbekannter Fehler: %ld\n", trid); break;
		}
	} else {
		resume_thread(trid);
		printf("Thread gestartet\n");
	}
}

//	nun kommt noch der Empfang der Nachricht QuitRequested!  

bool LogWin::QuitRequested()
{
	delete_port(pid_i);
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

int32 read_thread(void *btv) {
	BTextView *bTextView = (BTextView *)btv;
	BWindow *bw;
	port_id	pid;
	char	*buffer;
	size_t	p_len;
	int32	message;
	
	bw = bTextView->Window();
	if (bw->Lock()) {
		bTextView->Insert("And so it begins\n");
		bw->Unlock();
	}
	
	pid = find_port(PORT_NAME);
	if (pid >= B_NO_ERROR) {

		while ((p_len = port_buffer_size(pid)) >= B_NO_ERROR) {	// auf Nachrichten warten!

			buffer = (char *)malloc(p_len);	// Speicher für die Nachricht reservieren.
			if (buffer != NULL) {
				if (read_port(pid, &message, buffer, p_len) < B_NO_ERROR) break;
				if (bw->Lock()) {
					bTextView->Insert(buffer, p_len);
					bw->Unlock();
				}
			}
		}
	}
	
	return 0;
}