/*-------------------------------------------------------------------------
+-----------------------------------------------------------------------*/

// Ist die Variable DEBUG_FILE definiert, werden die Nachrichten
// mitprotokolliert und zwar in die Datei "DEBUG_FILE"
// Beim Start des Threads wird die Datei neu angelegt!

#define DEBUG_FILE "/var/log/link-server.log"
#include "Link.h"
#include "p_file.h"
#include "messages.h"

uint16	cid;				// Channelid!

#pragma export on
extern "C" __declspec(dllexport) int32 RunServer(void) {

	port_id			pid_o, pid_i;
	unsigned char	*buffer, *b;
	unsigned char   outb[256];
	char			*c, *c2, *c3;
	int				ergebnis, typ;
	int32			message;
	ssize_t 		p_len, i, send_len;
	BPath			*bp;
	BEntry			*bent;
	
#ifdef DEBUG_FILE
	FILE			*fd_debug;
	
	fd_debug = fopen(DEBUG_FILE, "w");
	if (fd_debug != NULL) {
		fprintf(fd_debug, "LINK-Server gestartet!\n");
		fclose(fd_debug);
	}
#endif

printf("LINK gestartet! Warte auf Channelid!\n");

	pid_i = find_port("LINK");			// Über diesen Port kommen die zu ankommenden Nachrichten
	pid_o = find_port("WritePsion");	// Über diesen Port gehen die zu versendenden Nachrichten

	if (pid_o < B_NO_ERROR || pid_i < B_NO_ERROR) exit_thread(pid_o);

	for (i = 0; i < 5; i++) {						// 5 Versuche wg. Rauschen :-)
		read_port(pid_i, &message, NULL, 0);		// die erste Nachricht die eingeht, ist der filedeskriptor!
		if ((message & CMD_MASK) == PSION_START) {
			cid = message & CID_MASK;
			break;									// for-schleife verlassen
		} else printf("LINK: Falsche message %lx %lx\n", message & CMD_MASK, PSION_START);
	}
	if (i >= 5) exit_thread(-1);

printf("LINK: Channelid erhalten: %d\n", cid);

	do {
		p_len = port_buffer_size(pid_i);			// Wie groß ist die Nachricht, die ankommt?
		if (p_len < B_NO_ERROR) exit_thread(p_len);	// Port wurde gelöscht?

		buffer = (unsigned char *)malloc(p_len);	// Speicher für die Nachricht reservieren.
		if (buffer != NULL) {
			read_port(pid_i, &message, buffer, p_len);

#ifdef DEBUG_FILE
	fd_debug = fopen(DEBUG_FILE, "a+");
	if (fd_debug != NULL) {
		fprintf(fd_debug, "\nLINK-IN :    ");
		for (i = 0; i < p_len; fprintf(fd_debug, "%02x ", buffer[i++])) ;
		fprintf(fd_debug, "\n   ASCII:    ");
		for (i = 0; i < p_len; i++) fprintf(fd_debug, " %c ", buffer[i] >= ' ' ? buffer[i] : '.');
		fprintf(fd_debug, "\n");
		fclose(fd_debug);
	}
#endif
			
			free(buffer);
		}
	} while (true);
}

#pragma export off
